// analytics set up
var _AnalyticsCode = 'UA-138347032-1';

var _gaq = _gaq || [];
_gaq.push(['_setAccount', _AnalyticsCode]);
_gaq.push(['_trackPageview']);
(function() {
	var ga = document.createElement('script');
	ga.type = 'text/javascript';
	ga.async = true;
	ga.src = 'https://ssl.google-analytics.com/ga.js';
	var s = document.getElementsByTagName('script')[0];
	s.parentNode.insertBefore(ga, s);
})();

// initial state, so opening popup will change storage value
chrome.storage.local.set({
	action: 'idle'
});

// analytics functions
function trackButtonClick(e) {
	_gaq.push(['_trackEvent', e.target.id, 'clicked']);
}

function trackThickness(thickness) {
	_gaq.push(['_trackEvent', thickness, 'thickness']);
}

function attach_events() {
	var query = { active: true, currentWindow: true };

	// popup triggered, change storage to run content.js functions
    chrome.storage.local.set({
    	action: 'triggered'
    });

    // take screenshot of active tab
	document.getElementById('screenshot').addEventListener('click', function(event) {
		chrome.tabs.query(query, function (tabs) {
			// Chrome's screenshot functionality
			chrome.tabs.captureVisibleTab( 
				chrome.windows.WINDOW_ID_CURRENT,
				function (src) {
					// pass in details for saving screenshot image file
					chrome.storage.local.set({ action: 'screenshot', screenshotURL: src, screenshotTitle: tabs[0] });
					// reset the storage state so you can take multiple screenshots in a row
					chrome.storage.local.set({ action: 'idle', screenshotURL: '', screenshotTitle: '' });
				}
			); 
		});
		trackButtonClick(event);
	});

	// clear canvas from page, show save button again
	document.getElementById('clear').addEventListener('click', function(event) {
	    chrome.tabs.query(query, function(activeTabs) {
	        chrome.storage.local.set({ action: 'clear' });
	    });
	    trackButtonClick(event);
	});

	// set thickness to previously selected value
	chrome.storage.local.get('thickness', function (result) {
		document.getElementById('thickness').value = result.thickness;
	});

	// update line thickness
	document.getElementById('thickness').addEventListener('change', function() {
		var thickness = this.value;
		trackThickness(thickness);
	    chrome.tabs.query(query, function(activeTabs) {
	        chrome.storage.local.set({ thickness: thickness });
	    });
	});

	// update colour choice
    [].forEach.call(document.getElementsByClassName('swatch'), (swatch) => {
    	swatch.addEventListener("click", function(event) {
	    	event.preventDefault();
	    	trackButtonClick(event);
	    	var colour = this.getAttribute('data-colour');
	    	chrome.tabs.query(query, function(activeTabs) {
		        chrome.storage.local.set({ colour: colour });
		    });
	    });
    });
}

document.addEventListener('DOMContentLoaded', function() {
	attach_events();
}, false);